/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.effect.PetImpl
 *  fire.pb.effect.Role
 *  fire.pb.effect.SPetAbilityScore
 *  fire.pb.map.SceneManager
 *  fire.pb.scoremanager.Module
 *  fire.pb.skill.Module
 *  fire.pb.skill.fight.FightSkillConfig
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.Misc
 *  gnet.link.Onlines
 *  mkdb.Mkdb
 *  mkio.Protocol
 *  xbean.PetInfo
 *  xtable.Properties
 */
package fire.pb.pet;

import fire.pb.effect.PetImpl;
import fire.pb.effect.Role;
import fire.pb.effect.SPetAbilityScore;
import fire.pb.map.SceneManager;
import fire.pb.pet.Module;
import fire.pb.pet.Pet;
import fire.pb.pet.PetAttr;
import fire.pb.pet.PetColumn;
import fire.pb.pet.PetManager;
import fire.pb.pet.SRefreshPetSkill;
import fire.pb.pet.SkillRate;
import fire.pb.skill.fight.FightSkillConfig;
import fire.pb.talk.MessageMgr;
import fire.pb.util.Misc;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import mkdb.Mkdb;
import mkio.Protocol;
import xbean.PetInfo;
import xtable.Properties;

public class CalcPetAttr {
    private final PetAttr petAttr;
    private final PetInfo petInfo;
    public static int PET_NAME = 3;
    public static int PET_GROW_RATE_ID = 4;

    public CalcPetAttr(PetInfo petInfo) {
        this.petInfo = petInfo;
        if (petInfo == null) {
            Module.logger.warn((Object)"[CalcPetAttr] 构造函数 petInfo == null");
            throw new IllegalArgumentException("参数错误,不能使用此类进行计算, petInfo == null");
        }
        this.petAttr = Module.getInstance().getPetManager().getAttr(petInfo.getId());
        if (this.petAttr == null) {
            Module.logger.warn((Object)("[CalcPetAttr] 构造函数  宠物数据表找不到宠物ID " + petInfo.getId()));
            throw new IllegalArgumentException("参数错误,不该使用此类进行计算, petAttr == null");
        }
    }

    public PetAttr getPetAttr() {
        return this.petAttr;
    }

    public void setPetAttrByInitAttrs(Map<Integer, Object> initAttrs) {
        this.initGrowRate();
        this.petInfo.setLife(this.getLifeFromConfig());
        if (initAttrs != null && initAttrs.containsKey(PET_NAME)) {
            this.petInfo.setName((String)initAttrs.get(PET_NAME));
        } else {
            this.petInfo.setName(this.getPetNameFromConfig());
        }
    }

    public String getPetNameFromConfig() {
        if (this.petAttr == null) {
            return null;
        }
        return this.petAttr.name;
    }

    public void setInitAttrPoint() {
        if (this.petInfo == null || this.petAttr == null) {
            return;
        }
        int[] point = new int[5];
        if (this.petAttr.getInitPointAssignType() == 1) {
            int n = this.petAttr.getInitPoint() / 5;
            int s = this.petAttr.getInitPoint() - n * 5;
            int i = 0;
            while (i < point.length) {
                point[i] = n;
                ++i;
            }
            point[3] = point[3] + s;
        } else if (this.petAttr.getInitPoint() >= 50) {
            Misc.RandomDistribute((int)(this.petAttr.getInitPoint() - 50), (int)5, (int[])point);
            int i = 0;
            while (i < point.length) {
                int n = i++;
                point[n] = point[n] + 10;
            }
        } else {
            int i = 0;
            while (i < point.length) {
                point[i] = 0;
                ++i;
            }
            if (this.petAttr.getInitPoint() > 0) {
                Misc.RandomDistribute((int)this.petAttr.getInitPoint(), (int)5, (int[])point);
            }
        }
        this.petInfo.getBfp().setCons(point[0]);
        this.petInfo.getBfp().setIq(point[1]);
        this.petInfo.getBfp().setStr(point[2]);
        this.petInfo.getBfp().setEndu(point[3]);
        this.petInfo.getBfp().setAgi(point[4]);
        this.petInfo.getInitbfp().setCons(this.petInfo.getBfp().getCons());
        this.petInfo.getInitbfp().setIq(this.petInfo.getBfp().getIq());
        this.petInfo.getInitbfp().setStr(this.petInfo.getBfp().getStr());
        this.petInfo.getInitbfp().setEndu(this.petInfo.getBfp().getEndu());
        this.petInfo.getInitbfp().setAgi(this.petInfo.getBfp().getAgi());
    }

    public int initGrowRate() {
        if (this.petInfo == null || this.petAttr == null) {
            return -1;
        }
        ArrayList<Integer> growRates = this.petAttr.getGrowrate();
        if (growRates.size() != 7) {
            return -1;
        }
        if (this.petAttr.getGrowrateconst() > 0) {
            this.petInfo.setGrowrate(this.petAttr.getGrowrateconst());
            return this.petAttr.getGrowrateconst();
        }
        int r = Mkdb.random().nextInt(growRates.size());
        if (r >= 0 && r < growRates.size()) {
            this.petInfo.setGrowrate(growRates.get(r).intValue());
            return growRates.get(r);
        }
        this.petInfo.setGrowrate(growRates.get(0).intValue());
        return growRates.get(0);
    }

    public void genPetSkill(PetInfo petInfo) {
        Pet pet = Pet.getPet(petInfo);
        pet.getBattleskills().clear();
        for (SkillRate skillRate : this.petAttr.getSkills()) {
            if (!Misc.checkRate((int)999, (int)skillRate.rate)) continue;
            pet.addSkill(skillRate.skillid, -1L, 0, 0);
        }
    }

    public static int getApt(int max, int min) {
        if (max == min) {
            return max;
        }
        if (max < min) {
            return -1;
        }
        int apt = Misc.getRandomBetween((int)min, (int)max);
        return apt;
    }

    public void setBornAttackApt(int attackapt) {
        if (this.petAttr == null || this.petInfo == null) {
            Module.logger.warn((Object)"[CalcPetAttr.setBornAttackApt] 参数错误");
            return;
        }
        if (attackapt < 0) {
            attackapt = this.petAttr.getAttackaptconst() > 0 ? this.petAttr.getAttackaptconst() : CalcPetAttr.getApt(this.petAttr.getAttackaptmax(), this.petAttr.getAttackaptmin());
        }
        if (attackapt >= 0) {
            this.petInfo.setBornattackapt(attackapt);
        }
    }

    public void setBornDefendApt(int defendapt) {
        if (this.petAttr == null || this.petInfo == null) {
            Module.logger.warn((Object)"[CalcPetAttr.setBornDefendApt] 参数错误");
            return;
        }
        if (defendapt < 0) {
            defendapt = this.petAttr.getDefendaptconst() > 0 ? this.petAttr.getDefendaptconst() : CalcPetAttr.getApt(this.petAttr.getDefendaptmax(), this.petAttr.getDefendaptmin());
        }
        if (defendapt >= 0) {
            this.petInfo.setBorndefendapt(defendapt);
        }
    }

    public void setBornPhyforceApt(int phyforceapt) {
        if (this.petAttr == null || this.petInfo == null) {
            Module.logger.warn((Object)"[CalcPetAttr.setBornPhyforceApt] 参数错误");
            return;
        }
        if (phyforceapt < 0) {
            phyforceapt = this.petAttr.getPhyforceaptconst() > 0 ? this.petAttr.getPhyforceaptconst() : CalcPetAttr.getApt(this.petAttr.getPhyforceaptmax(), this.petAttr.getPhyforceaptmin());
        }
        if (phyforceapt >= 0) {
            this.petInfo.setBornphyforceapt(phyforceapt);
        }
    }

    public void setBornMagicApt(int magicapt) {
        if (this.petAttr == null || this.petInfo == null) {
            Module.logger.warn((Object)"[CalcPetAttr.setBornMagicApt] 参数错误");
            return;
        }
        if (magicapt < 0) {
            magicapt = this.petAttr.getMagicaptconst() > 0 ? this.petAttr.getMagicaptconst() : CalcPetAttr.getApt(this.petAttr.getMagicaptmax(), this.petAttr.getMagicaptmin());
        }
        if (magicapt >= 0) {
            this.petInfo.setBornmagicapt(magicapt);
        }
    }

    public void setBornSpeedApt(int speedapt) {
        if (this.petAttr == null || this.petInfo == null) {
            Module.logger.warn((Object)"[CalcPetAttr.setBornSpeedApt] 参数错误");
            return;
        }
        if (speedapt < 0) {
            speedapt = this.petAttr.getSpeedaptconst() > 0 ? this.petAttr.getSpeedaptconst() : CalcPetAttr.getApt(this.petAttr.getSpeedaptmax(), this.petAttr.getSpeedaptmin());
        }
        if (speedapt >= 0) {
            this.petInfo.setBornspeedapt(speedapt);
        }
    }

    public void setBornDodgeApt(int dodgeapt) {
        if (this.petAttr == null || this.petInfo == null) {
            Module.logger.warn((Object)"[CalcPetAttr.setBornDodgeApt] 参数错误 ");
            return;
        }
        if (dodgeapt < 0) {
            dodgeapt = CalcPetAttr.getApt(0, 0);
        }
        if (dodgeapt >= 0) {
            this.petInfo.setBorndodgeapt(dodgeapt);
        }
    }

    public int getLifeFromConfig() {
        if (this.petAttr == null) {
            return 0;
        }
        return this.petAttr.getLife();
    }

    public static int doBaseScoreCalculate(Pet pet) {
        double score = 0.0;
        PetImpl epet = new PetImpl(pet.getPetInfo());
        int allPoint = epet.getAgi() + epet.getCons() + epet.getEndu() + epet.getIq() + epet.getStr();
        return (int)(score += (double)allPoint * fire.pb.scoremanager.Module.getInstance().getCoe(9));
    }

    public static double doCalculate(Pet pet) {
        double score = 0.0;
        PetImpl epet = new PetImpl(pet.getPetInfo());
        Map petScoreCnf = fire.pb.scoremanager.Module.getInstance().getPetAbility();
        for (SPetAbilityScore petScore : petScoreCnf.values()) {
            double attrValue = CalcPetAttr.getCurrentAttrValue(pet, petScore.id, (Role)epet);
            score += attrValue * petScore.score;
        }
        int allPoint = epet.getAgi() + epet.getCons() + epet.getEndu() + epet.getIq() + epet.getStr();
        score += (double)allPoint * fire.pb.scoremanager.Module.getInstance().getCoe(9);
        int skillScore = 0;
        for (int skillId : pet.getBattleskillIds()) {
            skillScore += PetManager.getInstance().getSkillScore(skillId);
        }
        score += (double)skillScore;
        int internalScore = 0;
        for (int skillId : pet.getBattleInternalIds()) {
            internalScore += PetManager.getInstance().getSkillScore(skillId);
        }
        score += (double)internalScore;
        int growRate = pet.getPetInfo().getGrowrate() - 952;
        if (growRate < 0) {
            growRate = 0;
        }
        return score += (double)growRate * fire.pb.scoremanager.Module.getInstance().getCoe(12) / 1000.0;
    }

    private static double getCurrentAttrValue(Pet pet, int attributeId, Role epet) {
        switch (attributeId) {
            case 1440: {
                return pet.getAttackapt();
            }
            case 1450: {
                return pet.getDefendapt();
            }
            case 1460: {
                return pet.getPhyforceapt();
            }
            case 1480: {
                return pet.getSpeedapt();
            }
            case 1470: {
                return pet.getMagicapt();
            }
            case 1490: {
                return pet.getDodgeapt();
            }
            case 130: {
                return epet.getAttack();
            }
            case 140: {
                return epet.getDefend();
            }
            case 60: {
                return epet.getMaxHp();
            }
            case 150: {
                return epet.getMagicAttack();
            }
            case 200: {
                return epet.getSpeed();
            }
            case 220: {
                return epet.getDodge();
            }
            case 160: {
                return epet.getMagicDef();
            }
            case 1500: {
                return (double)pet.getGrowrate() / 1000.0;
            }
            case 1430: {
                return pet.getUseLevel();
            }
        }
        return 0.0;
    }

    public static void graspPekSkillWhileUplevel(long roleId, int petKey) {
        PetColumn petCol = new PetColumn(roleId, 1, false);
        PetInfo petInfo = petCol.getPetInfo(petKey);
        if (petInfo == null) {
            return;
        }
        Pet pet = Pet.getPet(petInfo);
        if (!pet.canLearnNewSkillWhileUpLevel()) {
            return;
        }
        int graspSkillId = CalcPetAttr.getGraspSkillID(pet.getBattleskillIds(), pet.getPetAttr());
        if (-1 == graspSkillId) {
            return;
        }
        boolean succ = petCol.addSkill(petKey, graspSkillId, 0, 0);
        if (!succ) {
            return;
        }
        SRefreshPetSkill send = new SRefreshPetSkill();
        send.petkey = petKey;
        pet.fillSRefreshPetSkill(send);
        Onlines.getInstance().send(Long.valueOf(roleId), (Protocol)send);
        ArrayList<String> param = new ArrayList<String>();
        param.add(petInfo.getName());
        FightSkillConfig skillConfig = fire.pb.skill.Module.getInstance().getFightSkillConfig(graspSkillId);
        if (skillConfig == null) {
            return;
        }
        String colorRgb = Module.getInstance().getPetColorRGB(Pet.getClour(1));
        param.add(colorRgb);
        param.add(skillConfig.getSkillName());
        MessageMgr.psendMsgNotifyWhileCommit((long)roleId, (int)141705, param);
        String rolename = Properties.selectRolename((Long)roleId);
        List params = MessageMgr.getStringList((Object[])new Object[]{rolename, pet.getPetAttr().getName(), colorRgb, skillConfig.getSkillName()});
        SceneManager.psendAroundWhileCommit((long)roleId, (Protocol)MessageMgr.getMsgNotify((int)142722, (int)0, (List)params));
    }

    private static int getGraspSkillID(List<Integer> skills, PetAttr petAttr) {
        ArrayList<SkillRate> bornSkills = petAttr.getSkills();
        ArrayList<Integer> graspSkills = new ArrayList<Integer>();
        for (SkillRate rate : bornSkills) {
            if (skills.contains(rate.getSkillid())) continue;
            graspSkills.add(rate.getSkillid());
        }
        if (graspSkills.size() == 0) {
            return -1;
        }
        return (Integer)graspSkills.get(Misc.getRandomBetween((int)0, (int)(graspSkills.size() - 1)));
    }
}

